OpenTTD Source: OrdersWindow Struct Reference

OpenTTD Source 14.0-beta3

Public Member Functions | Static Public Attributes | Private Types | Private Member Functions | Private Attributes
OrdersWindow Struct Reference

Order window code for all vehicles. More...

Inheritance diagram for OrdersWindow:

## Public Member Functions
| OrdersWindow (WindowDesc *desc, const Vehicle *v)
void | UpdateWidgetSize (WidgetID widget, Dimension *size, [[maybe_unused]] const Dimension &padding, [[maybe_unused]] Dimension *fill, [[maybe_unused]] Dimension *resize) override
void | OnInvalidateData ([[maybe_unused]] int data=0, [[maybe_unused]] bool gui_scope=true) override
| Some data on this window has become invalid. More...
void | UpdateButtonState ()
void | OnPaint () override
| The window must be repainted. More...
void | DrawWidget (const Rect &r, WidgetID widget) const override
void | SetStringParameters (WidgetID widget) const override
void | OnClick ([[maybe_unused]] Point pt, WidgetID widget, [[maybe_unused]] int click_count) override
void | OnQueryTextFinished (char *str) override
void | OnDropdownSelect (WidgetID widget, int index) override
void | OnDragDrop (Point pt, WidgetID widget) override
EventState | OnHotkey (int hotkey) override
| A hotkey has been pressed. More...
void | OnPlaceObject ([[maybe_unused]] Point pt, TileIndex tile) override
bool | OnVehicleSelect (const Vehicle *v) override
bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end) override
| Clones an order list from a vehicle list. More...
void | OnPlaceObjectAbort () override
| The user cancelled a tile highlight mode that has been set.
void | OnMouseDrag (Point pt, WidgetID widget) override
void | OnResize () override
| Called after the window got resized. More...
Public Member Functions inherited from Window
| Window (WindowDesc *desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class. More...
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something. More...
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree. More...
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree. More...
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index. More...
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index. More...
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox. More...
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox. More...
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer. More...
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus. More...
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus. More...
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box. More...
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use. More...
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree. More...
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree. More...
template<typename T , std::enable_if_t< std::is_base_of< StrongTypedefBase, T >::value, int > = 0>
void | FinishInitNested (T number)
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget. More...
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget. More...
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget. More...
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled. More...
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled. More...
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget. More...
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window. More...
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus. More...
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget. More...
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget. More...
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered. More...
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised. More...
void | RaiseWidgetWhenLowered (byte widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered. More...
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget. More...
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus. More...
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget. More...
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget. More...
virtual void | InsertTextString (WidgetID wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget. More...
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks. More...
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in. More...
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window. More...
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets. More...
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets. More...
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered. More...
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e. More...
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol. More...
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner. More...
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size. More...
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded. More...
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing) More...
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized. More...
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window. More...
virtual void | DrawWidget ([[maybe_unused]] const Rect &r, [[maybe_unused]] WidgetID widget) const
| Draw the contents of a nested widget. More...
virtual void | UpdateWidgetSize ([[maybe_unused]] WidgetID widget, [[maybe_unused]] Dimension *size, [[maybe_unused]] const Dimension &padding, [[maybe_unused]] Dimension *fill, [[maybe_unused]] Dimension *resize)
| Update size and resize step of a widget in the window. More...
virtual void | SetStringParameters ([[maybe_unused]] WidgetID widget) const
| Initialize string parameters for a widget. More...
virtual void | OnFocus ()
| The window has gained focus. More...
virtual void | OnFocusLost (bool closing)
| The window has lost focus. More...
virtual EventState | OnKeyPress ([[maybe_unused]] char32_t key, [[maybe_unused]] uint16_t keycode)
| A key has been pressed. More...
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed. More...
virtual void | OnClick ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget, [[maybe_unused]] int click_count)
| A click with the left mouse button has been made on the window. More...
virtual bool | OnRightClick ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| A click with the right mouse button has been made on the window. More...
virtual void | OnHover ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it. More...
virtual bool | OnTooltip ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget, [[maybe_unused]] TooltipCloseCondition close_cond)
| Event to display a custom tooltip. More...
virtual void | OnMouseDrag ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible. More...
virtual void | OnDragDrop ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| A dragged 'object' has been released. More...
virtual void | OnScroll ([[maybe_unused]] Point delta)
| Handle the request for (viewport) scrolling. More...
virtual void | OnMouseOver ([[maybe_unused]] Point pt, [[maybe_unused]] WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window. More...
virtual void | OnMouseWheel ([[maybe_unused]] int wheel)
| The mouse wheel has been turned. More...
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick ([[maybe_unused]] uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownSelect ([[maybe_unused]] WidgetID widget, [[maybe_unused]] int index)
| A dropdown option associated to this window has been selected. More...
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed. More...
virtual void | OnEditboxChanged ([[maybe_unused]] WidgetID widget)
| The text in an editbox has been edited. More...
virtual void | OnQueryTextFinished ([[maybe_unused]] char *str)
| The query window opened from this window has closed. More...
virtual void | OnPlaceObject ([[maybe_unused]] Point pt, [[maybe_unused]] TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set. More...
virtual bool | OnVehicleSelect ([[maybe_unused]] const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set. More...
virtual bool | OnVehicleSelect ([[maybe_unused]] VehicleList::const_iterator begin, [[maybe_unused]] VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set. More...
virtual void | OnPlaceDrag ([[maybe_unused]] ViewportPlaceMethod select_method, [[maybe_unused]] ViewportDragDropSelectionProcess select_proc, [[maybe_unused]] Point pt)
| The user is dragging over the map when the tile highlight mode has been set. More...
virtual void | OnPlaceMouseUp ([[maybe_unused]] ViewportPlaceMethod select_method, [[maybe_unused]] ViewportDragDropSelectionProcess select_proc, [[maybe_unused]] Point pt, [[maybe_unused]] TileIndex start_tile, [[maybe_unused]] TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set. More...
virtual void | OnPlacePresize ([[maybe_unused]] Point pt, [[maybe_unused]] TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode. More...
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable? More...
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window. More...
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Static Public Attributes
static HotkeyList | hotkeys

## Private Types
enum | OrderPlaceObjectState { OPOS_NONE, OPOS_GOTO, OPOS_CONDITIONAL, OPOS_SHARE, OPOS_END }
| Under what reason are we using the PlaceObject functionality?
enum | DisplayPane { DP_GROUNDVEHICLE_ROW_NORMAL = 0, DP_GROUNDVEHICLE_ROW_CONDITIONAL = 1, DP_LEFT_LOAD = 0, DP_LEFT_REFIT = 1, DP_MIDDLE_UNLOAD = 0, DP_MIDDLE_SERVICE = 1, DP_RIGHT_EMPTY = 0, DP_RIGHT_REFIT = 1, DP_ROW_LOAD = 0, DP_ROW_DEPOT = 1, DP_ROW_CONDITIONAL = 2, DP_BOTTOM_MIDDLE_DELETE = 0, DP_BOTTOM_MIDDLE_STOP_SHARING = 1 }
| Displayed planes of the NWID_SELECTION widgets. More...

## Private Member Functions
VehicleOrderID | OrderGetSel () const
| Return the memorised selected order. More...
VehicleOrderID | GetOrderFromPt (int y)
| Calculate the selected order. More...
void | OrderClick_Goto (OrderPlaceObjectState type)
| Handle the click on the goto button.
void | OrderClick_FullLoad (OrderLoadFlags load_type, bool toggle=false)
| Handle the click on the full load button. More...
void | OrderClick_Service (int i)
| Handle the click on the service.
void | OrderClick_NearestDepot ()
| Handle the click on the service in nearest depot button.
void | OrderClick_Unload (OrderUnloadFlags unload_type, bool toggle=false)
| Handle the click on the unload button. More...
void | OrderClick_Nonstop (int non_stop)
| Handle the click on the nonstop button. More...
void | OrderClick_Skip ()
| Handle the click on the skip button. More...
void | OrderClick_Delete ()
| Handle the click on the delete button.
void | OrderClick_StopSharing ()
| Handle the click on the 'stop sharing' button. More...
void | OrderClick_Refit (int i, bool auto_refit)
| Handle the click on the refit button. More...
void | UpdateAutoRefitState ()
| Cache auto-refittability of the vehicle chain.

## Private Attributes
int | selected_order
VehicleOrderID | order_over
| Order over which another order is dragged, `INVALID_VEH_ORDER_ID` if none.
OrderPlaceObjectState | goto_type
const Vehicle * | vehicle
| Vehicle owning the orders being displayed and manipulated.
Scrollbar * | vscroll
bool | can_do_refit
| Vehicle chain can be refitted in depot.
bool | can_do_autorefit
| Vehicle chain can be auto-refitted.

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state. More...
static void | DeleteClosedWindows ()
| Delete all closed windows.
Data Fields inherited from Window
WindowDesc * | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
int | scale
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8_t | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root
| Root of the nested tree.
WidgetLookup | widget_lookup
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget
| ID of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
WindowList::iterator | z_position
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window. More...
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window. More...
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size. More...
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize
| Set if window has been resized.

## Detailed Description

Order window code for all vehicles.

At the bottom of the window two button rows are located for changing the orders of the vehicle.

# Top row

The top-row is for manipulating an individual order. What row is displayed depends on the type of vehicle, and whether or not you are the owner of the vehicle.

The top-row buttons of one of your trains or road vehicles is one of the following three cases:

    * +-----------------+-----------------+-----------------+-----------------+
    * |    NON-STOP     |    FULL_LOAD    |     UNLOAD      |      REFIT      | (normal)
    * +-----------------+-----+-----------+-----------+-----+-----------------+
    * |       COND_VAR        |    COND_COMPARATOR    |      COND_VALUE       | (for conditional orders)
    * +-----------------+-----+-----------+-----------+-----+-----------------+
    * |    NON-STOP     |      REFIT      |     SERVICE     |     (empty)     | (for depot orders)
    * +-----------------+-----------------+-----------------+-----------------+
    *

Airplanes and ships have one of the following three top-row button rows:

    * +-----------------+-----------------+-----------------+
    * |    FULL_LOAD    |     UNLOAD      |      REFIT      | (normal)
    * +-----------------+-----------------+-----------------+
    * |    COND_VAR     | COND_COMPARATOR |   COND_VALUE    | (for conditional orders)
    * +-----------------+--------+--------+-----------------+
    * |            REFIT         |          SERVICE         | (for depot order)
    * +--------------------------+--------------------------+
    *

# Bottom row

The second row (the bottom row) is for manipulating the list of orders:

    * +-----------------+-----------------+-----------------+
    * |      SKIP       |     DELETE      |      GOTO       |
    * +-----------------+-----------------+-----------------+
    *

For vehicles of other companies, both button rows are not displayed.

Definition at line 508 of file order_gui.cpp.

## Member Enumeration Documentation

## ◆ DisplayPane

enum OrdersWindow::DisplayPane
| private

Displayed planes of the NWID_SELECTION widgets.

Enumerator
DP_GROUNDVEHICLE_ROW_NORMAL | Display the row for normal/depot orders in the top row of the train/rv order window.
DP_GROUNDVEHICLE_ROW_CONDITIONAL | Display the row for conditional orders in the top row of the train/rv order window.
DP_LEFT_LOAD | Display 'load' in the left button of the top row of the train/rv order window.
DP_LEFT_REFIT | Display 'refit' in the left button of the top row of the train/rv order window.
DP_MIDDLE_UNLOAD | Display 'unload' in the middle button of the top row of the train/rv order window.
DP_MIDDLE_SERVICE | Display 'service' in the middle button of the top row of the train/rv order window.
DP_RIGHT_EMPTY | Display an empty panel in the right button of the top row of the train/rv order window.
DP_RIGHT_REFIT | Display 'refit' in the right button of the top row of the train/rv order window.
DP_ROW_LOAD | Display 'load' / 'unload' / 'refit' buttons in the top row of the ship/airplane order window.
DP_ROW_DEPOT | Display 'refit' / 'service' buttons in the top row of the ship/airplane order window.
DP_ROW_CONDITIONAL | Display the conditional order buttons in the top row of the ship/airplane order window.
DP_BOTTOM_MIDDLE_DELETE | Display 'delete' in the middle button of the bottom row of the vehicle order window.
DP_BOTTOM_MIDDLE_STOP_SHARING | Display 'stop sharing' in the middle button of the bottom row of the vehicle order window.

Definition at line 520 of file order_gui.cpp.

## Member Function Documentation

## ◆ GetOrderFromPt()

VehicleOrderID OrdersWindow::GetOrderFromPt | ( | int | y | ) |
| inlineprivate

Calculate the selected order.

The calculation is based on the relative (to the window) y click position and the position of the scrollbar.

Parameters

  y | Y-value of the click relative to the window origin

Returns
  The selected order if the order is valid, else return `INVALID_VEH_ORDER_ID`.

Definition at line 574 of file order_gui.cpp.

## ◆ OnHotkey()

EventState OrdersWindow::OnHotkey | ( | int | hotkey | ) |
| inlineoverridevirtual

A hotkey has been pressed.

Parameters

  hotkey | Hotkey index, by default a widget index of a button or editbox.

Returns
  ES_HANDLED if the key press has been handled, and the hotkey is not unavailable for some reason.

Reimplemented from Window.

Definition at line 1454 of file order_gui.cpp.

References _local_company, ES_NOT_HANDLED, and Vehicle::owner.

## ◆ OnInvalidateData()

void OrdersWindow::OnInvalidateData | ( | [[maybe_unused] ] int | data = `0`,
|  | [[maybe_unused] ] bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 849 of file order_gui.cpp.

References Window::CloseChildWindows(), GB(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >::Get(), Vehicle::GetNumOrders(), INVALID_VEH_ORDER_ID, Scrollbar::IsVisible(), Scrollbar::ScrollTowards(), Scrollbar::SetCount(), UpdateAutoRefitState(), VIWD_AUTOREPLACE, VIWD_CONSIST_CHANGED, VIWD_MODIFY_ORDERS, VIWD_REMOVE_ALL_ORDERS, and Window::window_number.

## ◆ OnPaint()

void OrdersWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1080 of file order_gui.cpp.

References _local_company, Window::DrawWidgets(), Vehicle::owner, Window::SetWidgetLoweredState(), and WID_O_GOTO.

## ◆ OnResize()

void OrdersWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1572 of file order_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_O_ORDER_LIST.

## ◆ OnVehicleSelect()

bool OrdersWindow::OnVehicleSelect | ( | VehicleList::const_iterator | begin,
|  | VehicleList::const_iterator | end
| ) |  |
| inlineoverride

Clones an order list from a vehicle list.

If this doesn't make sense (because not all vehicles in the list have the same orders), then it displays an error.

Returns
  This always returns true, which indicates that the contextual action handled the mouse click. Note that it's correct behaviour to always handle the click even though an error is displayed, because users aren't going to expect the default action to be performed just because they overlooked that cloning doesn't make sense.

Definition at line 1512 of file order_gui.cpp.

References _ctrl_pressed, AllEqual(), Vehicle::FirstShared(), Vehicle::GetNumOrders(), ShowErrorMessage(), VehiclesHaveSameOrderList(), and WL_INFO.

## ◆ OrderClick_FullLoad()

void OrdersWindow::OrderClick_FullLoad | ( | OrderLoadFlags | load_type,
|  | bool | toggle = `false`
| ) |  |
| inlineprivate

Handle the click on the full load button.

Parameters

  load_type | Load flag to apply. If matches existing load type, toggles to default of 'load if possible'.
  toggle | If we toggle or not (used for hotkey behavior)

Definition at line 605 of file order_gui.cpp.

References Order::GetLoadType(), Vehicle::GetOrder(), MOF_LOAD, OLF_LOAD_IF_POSSIBLE, OrderGetSel(), and Vehicle::tile.

## ◆ OrderClick_Nonstop()

void OrdersWindow::OrderClick_Nonstop | ( | int | non_stop | ) |
| inlineprivate

Handle the click on the nonstop button.

Parameters

  non_stop | what non-stop type to use; -1 to use the 'next' one.

Definition at line 680 of file order_gui.cpp.

References Order::GetNonStopType(), Vehicle::GetOrder(), Vehicle::IsGroundVehicle(), MOF_NON_STOP, ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS, OrderGetSel(), Window::SetWidgetDirty(), Vehicle::tile, and WID_O_NON_STOP.

## ◆ OrderClick_Refit()

void OrdersWindow::OrderClick_Refit | ( | int | i,
|  | bool | auto_refit
| ) |  |
| inlineprivate

Handle the click on the refit button.

If ctrl is pressed, cancel refitting, else show the refit window.

Parameters

  i | Selected refit command.
  auto_refit | Select refit for auto-refitting.

Definition at line 756 of file order_gui.cpp.

References _ctrl_pressed, CARGO_AUTO_REFIT, CARGO_NO_REFIT, OrderGetSel(), ShowVehicleRefitWindow(), and Vehicle::tile.

## ◆ OrderClick_Skip()

void OrdersWindow::OrderClick_Skip | ( |  | ) |
| inlineprivate

Handle the click on the skip button.

If ctrl is pressed, skip to selected order, else skip to current order + 1

Definition at line 702 of file order_gui.cpp.

References _ctrl_pressed, BaseConsist::cur_implicit_order_index, Vehicle::GetNumOrders(), and Vehicle::tile.

## ◆ OrderClick_StopSharing()

void OrdersWindow::OrderClick_StopSharing | ( |  | ) |
| inlineprivate

Handle the click on the 'stop sharing' button.

If 'End of Shared Orders' isn't selected, do nothing. If Ctrl is pressed, call OrderClick_Delete and exit. To stop sharing this vehicle order list, we copy the orders of a vehicle that share this order list. That way we exit the group of shared vehicles while keeping the same order list.

Definition at line 732 of file order_gui.cpp.

References _ctrl_pressed, Vehicle::FirstShared(), Vehicle::IsOrderListShared(), Vehicle::NextShared(), OrderClick_Delete(), Vehicle::PreviousShared(), Vehicle::tile, and vehicle.

## ◆ OrderClick_Unload()

void OrdersWindow::OrderClick_Unload | ( | OrderUnloadFlags | unload_type,
|  | bool | toggle = `false`
| ) |  |
| inlineprivate

Handle the click on the unload button.

Parameters

  unload_type | Unload flag to apply. If matches existing unload type, toggles to default of 'unload if possible'.
  toggle | If we toggle or not (used for hotkey behavior)

Definition at line 655 of file order_gui.cpp.

References Vehicle::GetOrder(), Order::GetUnloadType(), MOF_LOAD, MOF_UNLOAD, OLFB_NO_LOAD, OrderGetSel(), OUF_UNLOAD_IF_POSSIBLE, OUFB_TRANSFER, OUFB_UNLOAD, Window::SetWidgetDirty(), Vehicle::tile, and WID_O_FULL_LOAD.

## ◆ OrderGetSel()

VehicleOrderID OrdersWindow::OrderGetSel | ( |  | ) | const
| inlineprivate

Return the memorised selected order.

Returns
  the memorised order if it is a valid one else return the number of orders

Definition at line 560 of file order_gui.cpp.

References Vehicle::GetNumOrders(), and vehicle.

Referenced by OrderClick_FullLoad(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), and OrderClick_Unload().

## Field Documentation

## ◆ hotkeys

HotkeyList OrdersWindow::hotkeys
| inlinestatic

Initial value:
{"order", {
Hotkey('D', "skip", OHK_SKIP),
Hotkey('F', "delete", OHK_DELETE),
Hotkey('G', "goto", OHK_GOTO),
Hotkey('H', "nonstop", OHK_NONSTOP),
Hotkey('J', "fullload", OHK_FULLLOAD),
Hotkey('K', "unload", OHK_UNLOAD),
Hotkey(0, "nearest_depot", OHK_NEAREST_DEPOT),
Hotkey(0, "always_service", OHK_ALWAYS_SERVICE),
Hotkey(0, "transfer", OHK_TRANSFER),
Hotkey(0, "no_unload", OHK_NO_UNLOAD),
Hotkey(0, "no_load", OHK_NO_LOAD),
}}

Definition at line 1578 of file order_gui.cpp.

The documentation for this struct was generated from the following file:

- src/order_gui.cpp

Hotkey
All data for a single hotkey.
Definition: hotkeys.h:21